unit FenetreForm;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Menus, DXClass, DXSprite, DXInput, DXDraws, DIB;

type
  TFenetre = class(TDXForm)
    DXTimer: TDXTimer;
    DXDraw: TDXDraw;
    DXSpriteEngine: TDXSpriteEngine;
    DXInput: TDXInput;
    ImageList: TDXImageList;
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure DXDrawFinalize(Sender: TObject);
    procedure DXDrawInitialize(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure DXTimerTimer(Sender: TObject; LagCount: Integer);
    procedure DXDrawClick(Sender: TObject);
  end;

var
  Fenetre: TFenetre;
  Xi, Yi : Double;

implementation

uses
  Outils, TestConfigForm, InteractionForm;

{$R *.DFM}

type

  TMonoSprite = class(TImageSprite)
  private
    FCounter: Double;
  public
    procedure DoMove(MoveCount: Integer); override;
  end;

  TPlayerSprite = class(TImageSprite)
  protected
    procedure DoMove(MoveCount: Integer); override;
  end;

procedure TMonoSprite.DoMove(MoveCount: Integer);
var
  Decalage: integer;
begin
  Decalage:=Random(10);
  X:=X+Decalage-Random(2*Decalage+1);
  {if random(2)=0 then X:=X+Decalage else X:=X-Decalage}
  Y:=Y+Decalage-Random(2*Decalage+1);
  {if random(2)=0 then Y:=Y+Decalage else Y:=Y-Decalage}
end;

procedure TPlayerSprite.DoMove(MoveCount: Integer);
var
  Limite:Double;
begin
  if isUp in Fenetre.DXInput.States then Y := Y - 10 * MoveCount;
  {flche vers le haut / Y:Double, nombre rel}
  if isDown in Fenetre.DXInput.States then Y := Y + 10 * MoveCount;
  {flche vers le bas / Y:Double, nombre rel}
  if isLeft in Fenetre.DXInput.States then X := X - 10 * MoveCount;
  {flche vers la gauche / X:Double, nombre rel}
  if isRight in Fenetre.DXInput.States then X := X + 10 * MoveCount;
  {flche vers la droite / X:Double, nombre rel}

  Limite:=100+Random(2400);
  if X<-Limite then X:=2500-Random(5000);
  if Y<-Limite then Y:=2500-Random(5000);
  if X>Limite then X:=2500-Random(5000);
  if Y>Limite then Y:=2500-Random(5000);

  Xi:=X;
  Yi:=Y;

  Engine.X := -X+(Engine.Width+-Width) div 2 -200;  {-200 pour sortir du cercle}
                                {car erreur d'affichage sur carte graphique ATI}
  {Width: largeur de la fentre}
  Engine.Y := -Y+(Engine.Height-Height) div 2;
  {Height: hauteur de la fentre}
  {le fond se dplace de -X quand le PlayerSprite se dplace de +X
           se dplace de +X quand le PlayerSprite se dplace de -X
           se dplace de -Y quand le PlayerSprite se dplace de +Y
           se dplace de +Y quand le PlayerSprite se dplace de -Y
  => immobilit apparente du PlayerSprite}
end;

procedure TFenetre.DXTimerTimer(Sender: TObject; LagCount: Integer);
begin
  if not DXDraw.CanDraw then exit;
  DXDraw.Surface.Fill($000000);
  DXSpriteEngine.Draw;

  DXInput.Update;

  DXSpriteEngine.Move(LagCount);
  DXSpriteEngine.Dead;

  {  Description  }

  DXDraw.Flip; {le contenu de la surface est envoy  l'cran}
end;

procedure TFenetre.DXDrawFinalize(Sender: TObject);
begin
  DXTimer.Enabled := False;
end;

procedure TFenetre.DXDrawInitialize(Sender: TObject);
begin
  DXTimer.Enabled := True;
end;

procedure TFenetre.FormCreate(Sender: TObject);
var
  i: Integer;
  PlayerSprite: TSprite;
  R: HRgn;
begin
  Fenetre.Top:=0;
  Fenetre.Left:=0;
  Fenetre.Height:=600;
  Fenetre.Width:=800;
  Randomize;
  R:=CreateEllipticRgn(200,100,600,500);
  SetWindowRgn(Handle,R,True);
  ImageList.Items.MakeColorTable;

  DXDraw.ColorTable := ImageList.Items.ColorTable;
  DXDraw.DefColorTable := ImageList.Items.ColorTable;
  DXDraw.UpdatePalette;

  With TBackgroundSprite.Create(DXSpriteEngine.Engine) do
  begin
    SetMapSize(1,1);
    Image:=ImageList.Items.Find('arrire plan');
    Z:=0;
    Tile:=True;
  end;

  for i:=0 to 300 do
    with TMonoSprite.Create(DXSpriteEngine.Engine) do
    begin
      Image := ImageList.Items.Find('brique');
      X := Random(5000)-2500;  {coord. X de l'ennemi de -250  250}
      Y := Random(5000)-2500;  {coord. Y de l'ennemi de -250  250}
      Z := 2;                  {coord. Z de l'ennemi}
      Width := Image.Width;
      Height := Image.Height;
      FCounter := Random(MaxInt);
    end;

  PlayerSprite:=TPlayerSprite.Create(DXSpriteEngine.Engine);
  With TPlayerSprite(PlayerSprite) do
  begin
    Image:=ImageList.Items.Find('joueur');
    X:=0;
    Y:=0;
    Z:=1;
    Width:=Image.Width;
    Height:=Image.Height;
  end;

end;

procedure TFenetre.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  Case Key of
  VK_ESCAPE : Close;
  VK_F1 : Application.CreateForm(TInteraction, Interaction);
  end;
end;

procedure TFenetre.DXDrawClick(Sender: TObject);
begin
  if DXTimer.Enabled then DXTimer.Enabled:=False
                     else DXTimer.Enabled:=True;
end;


end.

